var ThemePicker = /** @class */ (function () {
    function ThemePicker() {
    }
    ThemePicker.prototype.select = function (name) {
        selectTheme(ThemePicker.themes[name]);
    };
    ThemePicker.prototype.exists = function (name) {
        return ThemePicker.themes.hasOwnProperty(name);
    };
    ThemePicker.themes = {
        bootstrap4: [
            'https://cdnjs.cloudflare.com/ajax/libs/twitter-bootstrap/4.1.1/css/bootstrap.css',
            'https://cdn.datatables.net/1.10.19/css/dataTables.bootstrap4.min.css'
        ]
    };
    return ThemePicker;
}());
export default ThemePicker;
function selectTheme(hrefs) {
    var links = [];
    hrefs.forEach(function (href) {
        var link = document.createElement('link');
        link.rel = "stylesheet";
        link.type = "text/css";
        link.href = href;
        if (document.head) {
            document.head.appendChild(link);
        }
    });
    return new Promise(function (resolve, reject) {
        links.forEach(function (link) {
            link.onload = function (event) {
                var styleTag = event.target;
                if (styleTag) {
                    var sheet = styleTag.sheet;
                    resolve(sheet);
                }
            };
            link.onerror = reject;
        });
    });
}
